(document:surround "/std/frame")

;;; Logic (qt and html)

(define (default-zone cmd cmdlist)
  (let ((zone (woo-get-option cmd 'zone)))
    (if (and (string-null? zone) (pair? cmdlist))
        (woo-get-option (car cmdlist) 'name)
        zone)))

(define (update-ctime-value utc zone)
  (form-update-value-list '("ctime") (woo-first-command (woo "ctime" "/datetime-installer" 'utc  utc 'zone zone))))

(define (update-zonelist)
  (let* ((name (form-value "name"))
	 (zone-list (woo-list "/datetime-installer/avail_zone"
			      'name name))
	 (zone (default-zone (woo-read-first "/datetime-installer" 'name name) zone-list)))
    (form-update-enum "zone" zone-list)
    (form-update-value "zone" zone)
    (update-ctime-value (form-value "utc") zone)))

(define (update-ctime)
  (update-ctime-value (form-value "utc") (form-value "zone")))

;;; Logic (qt specific)

;;TODO: optimize it
(define (ui-init)
  (catch/message
    (lambda()
      (form-update-enum "name" (woo-list "/datetime-installer/avail_country"))
      (form-update-enum "zone" (woo-list "/datetime-installer/avail_zone"))
      (form-update-value-list '("name" "zone" "utc" "ctime") (woo-read-first "/datetime-installer")))))

(define (ui-commit)
  (catch/message
    (lambda()
      (apply woo-write "/datetime-installer" (cons* 'commit #t (form-value-list))))))

(define (ui-edit)
  (ui-commit)
  (form-popup "/datetime/installer/edit")
  (update-ctime))

(define (form-init)
  (ui-init)
  (form-bind "name" "change" update-zonelist)
  (form-bind "zone" "change" update-ctime)
  (form-bind "utc" "change" update-ctime)
  (form-bind "edit" "click" ui-edit))

;;; UI

(gridbox
  margin 50

  (label name "name" text (_ "Please, select country:") align "left")
  (combobox name "name")
  (label)

  (label name "zone" text (_ "Please, select time zone:") align "left")
  (listbox name "zone")
  (checkbox name "utc" text (_ "Hardware time set to GMT"))
  (label)

  (hbox
   align "left"
   (label text (_ "Current time:"))
   (label name "ctime")
   (button name "edit" text (_ "Change...")))

  (label))

;;; initialization

(document:root (when loaded (form-init)))

(frame:on-next (thunk (or (ui-commit) 'cancel)))
(frame:on-back (thunk (or (ui-commit) 'cancel)))

