(define-module (ui datetime system ajax)
	       :use-module (alterator ajax)
	       :use-module (alterator woo)
	       :use-module (alterator effect)
	       :export (init))

(define (ui-timezone)
  (form-replace "/datetime/system/timezone"))

(define (ui-timeedit)
  (catch/message
    (lambda()
      (form-update-value-list
	'("time")
	(woo-read-first "/datetime-system")))))

(define (ui-write)
  (catch/message
    (lambda()
      (apply woo-write "/datetime-system"
	     'language (form-value "language")
	     (form-value-list))
      (ui-read))))

(define (ui-read)
  (catch/message
    (lambda()
      (form-update-value-list
	'("date" "time" "ntp_status" "ntp_pool" "ntp_accept" "utc" "timezone")
	(woo-read-first "/datetime-system" 'language (form-value "language")))
      (update-effect))))

(define (init)
  ;; effects
  (effect-disable "ntp_pool" "ntp_status" #f)
  (effect-disable "ntp_accept" "ntp_status" #f)
  (effect-disable "date" "ntp_status" #t)
  (effect-disable "time" "ntp_status" #t)
  (init-effect)
  ;; form
  (ui-read)
  ;; events
  (form-bind "apply" "click" ui-write)
  (form-bind "reset" "click" ui-read)
  (form-bind "change-zone" "click" ui-timezone)
  (form-bind-timeedit "time" ui-timeedit))
