(document:surround "/std/frame")

(define (ui-write)
  (catch/message
    (lambda()
	(apply woo-write "/datetime-system" (form-value-list))
	(ui-read))))

(define (ui-read)
  (form-update-value-list '("date" "time" "ntp_status" "ntp_pool" "ntp_accept" "utc" "timezone")
                           (woo-read-first "/datetime-system")))

(define (ui-timezone)
  (form-popup "/datetime/system/timezone")
  (ui-read))

(gridbox columns "50;50"
       margin 20
       (gridbox
         columns "50;50"
         colspan 2
         align "left"
         (checkbox text (_ "Get time from NTP server:") name "ntp_status")
         (hbox (label name "ntp_pool" text (_ "NTP server:") visibility #f)
               (edit name "ntp_pool")))

       (checkbox text (_ "Work as NTP server") widget-name "ntp_accept" name "ntp_accept")
       (spacer)

       (separator colspan 2)

       (label text (_ "Current date:") align "center" name "date")
       (label text (_ "Current time:") align "center" name "time")

       (dateedit expanded #t name "date")
       (timeedit expanded #t name "time")

       (label colspan 2)

       (checkbox name "utc" text (_ "Hardware time set to GMT"))
       (spacer)

       (hbox
         align "left"
         (label text (_ "Time zone:"))
         (label text " ")
         (label name "timezone")
         (label text " ")
         (button name "change-zone" text (_ "Change...")))
       (spacer)

       (label colspan 2)

       (button name "apply" text (_ "Apply") align "left")
       (spacer))

(effect-disable "ntp_pool" "ntp_status" #f)
(effect-disable "ntp_accept" "ntp_status" #f)
(effect-disable "date" "ntp_status" #t)
(effect-disable "time" "ntp_status" #t)

(document:root
  (when loaded
    (ui-read)
    (form-bind "apply" "click" ui-write)
    (form-bind "change-zone" "click" ui-timezone)
    (init-effect)))
