(define-module (ui datetime system timezone ajax)
	       :use-module (alterator ajax)
	       :use-module (alterator woo)
	       :export (init))

(define (default-zone cmd cmdlist)
  (let ((zone (woo-get-option cmd 'zone)))
    (if (and (string-null? zone) (pair? cmdlist))
        (woo-get-option (car cmdlist) 'name)
        zone)))

(define (update-zonelist)
  (let* ((name (form-value "name"))
	 (zone-list (woo-list "/datetime-system/avail_zone"
			      'name name
			      'language (form-value "language"))))
    (form-update-enum "zone" zone-list)
    (form-update-value "zone" (default-zone (woo-read-first "/datetime-system/timezone" 'name name)
					    zone-list))))

(define (ui-read)
  (form-update-enum "name"
    (woo-list "/datetime-system/avail_country" 'language (form-value "language")))
  (form-update-enum "zone"
    (woo-list "/datetime-system/avail_zone" 'language (form-value "language")))
  (form-update-value-list
    '("name" "zone")
    (woo-read-first "/datetime-system/timezone" 'language (form-value "language"))))

(define (ui-write)
  (catch/message
   (lambda()
     (apply woo-write "/datetime-system/timezone"
            'language (form-value "language")
	    (form-value-list)))))

(define (ui-return)
  (form-replace "/datetime/system"))

(define (init)
  (ui-read)
  (form-bind "name" "change" update-zonelist)
  (form-bind "ok" "click" (lambda() (and (ui-write) (ui-return)))))
