(document:surround "/std/frame")

;;; Logic

(define (default-zone cmd cmdlist)
  (let ((zone (woo-get-option cmd 'zone)))
    (if (and (string-null? zone) (pair? cmdlist))
        (woo-get-option (car cmdlist) 'name)
        zone)))

(define (update-zonelist)
  (let* ((name (form-value "name"))
	 (zone-list (woo-list "/datetime-system/avail_zone" 'name name)))
    (form-update-enum "zone" zone-list)
    (form-update-value "zone" (default-zone (woo-read-first "/datetime-system/timezone" 'name name)
					    zone-list))))

(define (ui-read)
  (form-update-enum "name"
    (woo-list "/datetime-system/avail_country" 'language (form-value "language")))
  (form-update-enum "zone"
    (woo-list "/datetime-system/avail_zone" 'language (form-value "language")))
  (form-update-value-list
    '("name" "zone")
    (woo-read-first "/datetime-system/timezone" 'language (form-value "language"))))

(define (ui-write)
  (catch/message
   (lambda()
     (apply woo-write "/datetime-system/timezone"
            'language (form-value "language")
	    (form-value-list)))))

(define (ui-return)
  (document:end))

(define (ui-init)
  (ui-read)
  (form-bind "name" "change"  update-zonelist)
  (form-bind "ok" "click" (lambda() (and (ui-write) (ui-return))))
  (form-bind "cancel" "click" ui-return))

;;; UI

(gridbox
  margin "50"

  ;;
  (label name "name" text (_ "Please, select country:") align "left")
  (combobox name "name")
  (label)

  ;;
  (label text (_ "Please, select time zone:") align "left")
  (listbox name "zone")
  (label)

  ;;
  (if (global 'frame:next-button)
    (label)
    (hbox align "left"
	  (button name "ok" text (_ "OK"))
	  (button name "cancel" text (_ "Cancel")))))

;;; initialization

(document:root (when loaded (ui-init)))
