#!/bin/sh -efu
# ***** BEGIN LICENSE BLOCK *****
# * Copyright (C) 2007  Alexey Gladkov <legion@altlinux.org>
# *
# * This program is free software; you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation; either version 2 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program; if not, write to the Free Software
# * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# ***** END LICENSE BLOCK *****

. install2-init-functions
. shell-config

copy_ntpd_conf()
{
	[ -f "$1" ] || return 0

	cp "$1" "$destdir/etc/"
	# Remove all dynamically added entries
	sed -i '/^# Generated by/,/^# End of/d' "$destdir/$1"
}

[ ! -f '/etc/localtime' ] ||
	cp -af '/etc/localtime' "$destdir/etc/"

[ ! -f '/etc/sysconfig/clock' ] ||
	cp -af '/etc/sysconfig/clock' "$destdir/etc/sysconfig/"

[ ! -s '/etc/adjtime' ] ||
	cp -af '/etc/adjtime' "$destdir/etc/"

copy_ntpd_conf /etc/ntpd.conf
copy_ntpd_conf /etc/ntp.conf

! chkconfig --list ntpd |grep -qs '[0-9]:on' || run_chroot chkconfig ntpd on || :

if [ -d "$destdir/etc/alterator/dhcp" ]; then
    client_ntp="$(shell_config_get /var/lib/alterator/alterator-dhcp-general client_ntp)"
    [ -z "$client_ntp" ] ||
	shell_config_set "$destdir/etc/alterator/dhcp/general" client_ntp "$client_ntp"
fi
